const gulp = require('gulp');
const inlineNg2Template = require('gulp-inline-ng2-template');
const merge = require('merge-stream');

gulp.task('inline-build-templates', () => {
    let task1 =  gulp.src(['./src/app/shared/**/*.ts'])
                    .pipe(inlineNg2Template({target: 'es5', useRelativePaths: true
                 }))
                .pipe(gulp.dest('./build/shared'));
    let task2 =  gulp.src(['./src/app/base/**/*.ts'])
                    .pipe(inlineNg2Template({target: 'es5', useRelativePaths: true
                }))
                .pipe(gulp.dest('./build/base'));
    let task3 =  gulp.src(['./src/app/developerlibrary/**/*.ts'])
                    .pipe(inlineNg2Template({target: 'es5', useRelativePaths: true
                }))
                .pipe(gulp.dest('./build/developerlibrary'));
    let task4 =  gulp.src(['./e2e/shared/**/*.po.ts'])
                    .pipe(inlineNg2Template({target: 'es5', useRelativePaths: true
                }))
                .pipe(gulp.dest('./build/e2e/shared'));
    return merge(task1, task2, task3, task4);
});

gulp.task('prepare-post', () => {
    let task1 =  gulp.src(['./package.json', './README.md', './src/styles-prime.css']).pipe(gulp.dest('./dist'));
    let task2 =  gulp.src(['./src/scss/**/*.scss'])
                    .pipe(inlineNg2Template({target: 'es5', useRelativePaths: true
                 }))
                .pipe(gulp.dest('./dist/scss'));
    return merge(task1, task2);
});