import { Component } from "@angular/core";
import { Router } from "@angular/router";
import { MenuItem } from "primeng/components/common/api";
import { Subscription } from "rxjs";
import { LoginService } from "./common/service/login.service";
import { UsuarioDTO } from "./common/dto/usuarioDTO";

@Component({
  selector: "app-root",
  templateUrl: "./app.component.html"
})
export class AppComponent {
  title = "Shared";
  items: MenuItem[];
  usuario: UsuarioDTO;

  private subscriptionLogin: Subscription;

  constructor(public loginService: LoginService, public router: Router) {
    this.usuario = new UsuarioDTO(1, "developer", "devop");
  }

  ngOnInit() {
    this.items = [
      {
        label: "Usuaris",
        items: [[{ items: [{ label: "Cerca d'usuaris", icon: "fa fa-users", routerLink: ["usuarios"] }] }]]
      },
      {
        label: "Test",
        items: [
          [
            { items: [{ label: "Old components", icon: "fa fa-users", routerLink: ["test/form"] }] },
            { items: [{ label: "New components", icon: "fa fa-users", routerLink: ["test/newform"] }] }
          ]
        ]
      },
      {
        label: "Developer",
        items: [
          [
            { items: [{ label: "Logs", icon: "fa fa-bars", routerLink: ["developer/logs"] }] },
            {
              items: [{ label: "Excepcions", icon: "fa fa-exclamation-triangle", routerLink: ["developer/exceptions"] }]
            },
            { items: [{ label: "Consultes a B. DD.", icon: "fa fa-pencil-square-o", routerLink: ["developer/hql"] }] },
            { items: [{ label: "Configuració", icon: "fa fa-pencil-square-o", routerLink: ["developer/config"] }] }
          ]
        ]
      }
    ];
  }
}
