import {ModuleWithProviders}  from '@angular/core';
import {Routes, 
        RouterModule,
        PreloadAllModules}    from '@angular/router';

export const routes: Routes = [
  {path: '', redirectTo: 'home', pathMatch: 'full'},
  {path: 'usuarios', loadChildren: './home/home.module#HomeModule', 
                     resolve: { url: 'externalUrlRedirectResolver' }, data: { externalUrl: 'http://www.google.es/' } },
  {path: 'test', loadChildren: './test/test.module#TestModule'},
  {path: 'developer', loadChildren: './developer/developer.module#DeveloperModule' }
];

export const routing: ModuleWithProviders = RouterModule.forRoot(routes, 
                                                                {preloadingStrategy: PreloadAllModules});