/**
 * Clase base que contiene lo mínimo necesario para almacenar un filtro de búsqueda.
 */
export abstract class BaseFilter
{
   public static RESULTADOS_PAGE:number = 20;
   public static PAGE           :number =  1;
   public static PAGE_LINK_SIZE :number =  5;
    
   /*
    * Ejemplo de uso de columnasOrdenacion:

        public static newObject(): CustomFilter {
            let filter = new PlantillaFilter(null, CustomFilter.getDefaultOrder(), BaseFilter.RESULTADOS_PAGE, BaseFilter.PAGE);
            return filter;
        }

        public static getDefaultOrder(): string[] {
            return  ['-nombre', 'id'];
        }
    */
   public columnasOrdenacion: string[];

   constructor(
      public resultados: number,
      public pagina: number
   ) {
   }
   
   public reset() {
      this.resultados = BaseFilter.RESULTADOS_PAGE;
      this.pagina     = BaseFilter.PAGE;
   }
}