import {NgModule, 
        Optional,
        SkipSelf}                   from '@angular/core';

import {SharedModule}               from '../shared/shared.module';
import {LoginService}               from './service/login.service';
import {ConfiguracionService}       from '../developerlibrary/shared/service/configuracion.service';
import {environment}                from '../../environments/environment';

import { httpUtilsServiceInjectables }  from '../shared/service/http-utils.service';
import { UploadService }                from '../shared/service/upload.service';
import { MessageService }               from '../shared/service/message.service';
import { GeneralUtils }                 from '../shared/service/general-utils.service';
import { CustomValidators }             from '../shared/service/custom-validators.service';
import { FocusService }                 from '../shared/service/focus.service';
import { DomainService }                from '../shared/service/domain.service';
import { DomainCachedService }          from '../shared/service/domain-cached.service';
import { SessionSharedService }         from '../shared/service/session-shared.service';
import { AyudaService }                 from '../shared/service/ayuda.service';
import { DomainResolve }                from '../shared/resolve/domain.resolve';
import { ToolbarService }               from '../shared/service/toolbar.service';
import { TableViewService }             from '../shared/service/tableview.service';

@NgModule({
    imports: [
        SharedModule
    ],
    providers: [
        {provide: 'API_URL', useValue: environment.API_URL} // Se provee API_URL para que la utilize HttpUtilsService, UploadService, etc
        // ,{provide: 'DOWNLOAD_URL', useValue: environment.DOWNLOAD_URL}
        ,{provide: 'CONTEXT_PATH', useValue: environment.CONTEXT}
        ,httpUtilsServiceInjectables  
        ,UploadService
        ,MessageService
        ,GeneralUtils
        ,CustomValidators
        ,FocusService 
        ,DomainService
        ,DomainCachedService
        ,SessionSharedService
        ,AyudaService
        ,DomainResolve
        ,ToolbarService
        ,TableViewService
        ,LoginService
        ,ConfiguracionService
        ],
    exports: [
        SharedModule
    ]     
})
export class CommonModule {

    constructor (@Optional() @SkipSelf() parentModule: CommonModule) {
        if (parentModule) {
            throw new Error(
            'CommonModule is already loaded. Import it in the AppModule only');
        }
    }
}