import { ModuleWithProviders } from '@angular/core';
import { RouterModule }        from '@angular/router';

import { DeveloperComponent  } from './developer.component';
import { HQLComponent } from '../developerlibrary/hql/hql.component';
import { LogListComponent } from '../developerlibrary/log/log-list.component';
import { DomainResolve } from '../shared/resolve/domain.resolve';
import { LogListNoFiltroComponent } from '../developerlibrary/log/log-list-nofiltro.component';
import { LogListNadaComponent } from '../developerlibrary/log/log-list-nada.component';
import { ExceptionListComponent } from '../developerlibrary/exception/exception-list.component';
import { UploadComponent } from '../developerlibrary/upload/upload.component';
import { ConfigListComponent, ConfigFormComponent } from '../developerlibrary/config';

export const routing: ModuleWithProviders = RouterModule.forChild([  
   { 
      path: '', 
      component: DeveloperComponent,
      children: [
         { path: 'hql',             component: HQLComponent           },
         { path: 'logs',            component: LogListComponent, data: {dominios: ['tipoLog']}, resolve: { dominios: DomainResolve } },
         { path: 'logs-nofiltro',   component: LogListNoFiltroComponent},
         { path: 'logs-nada',       component: LogListNadaComponent},
         { path: 'exceptions',      component: ExceptionListComponent },
         { path: 'upload',          component: UploadComponent},
         { path: 'config'         , component: ConfigListComponent },
         { path: 'config/form/:id', component: ConfigFormComponent },
         { path: 'config/form'    , component: ConfigFormComponent },
      ]
   }
]);