import { Component, Input } from '@angular/core';
import { Router, ActivatedRoute }  from '@angular/router';

import { Item } from '../../shared/data/item';

@Component({
    selector: 'config-list-tableview',
    template: `
        <p-dataTable [value]="items" (onRowClick)="gotoForm($event)" selectionMode="single" *ngIf="(items != null && items.length > 0)">
            <p-column field="codigo" header="Codi" [sortable]="true"></p-column>
            <p-column field="valor" header="Valor" [sortable]="true"></p-column>
        </p-dataTable> 
     `
})
export class ConfigListTableViewComponent {
    @Input() items: Item[];

    constructor(
        private router: Router, 
        protected activatedRoute: ActivatedRoute,
    ) {}

    gotoForm(event) {
        this.router.navigate(['form', event.data.codigo], {relativeTo: this.activatedRoute}); //, {relativeTo: this.activatedRoute}
   }
}