import {NgModule}               from '@angular/core';
/* Other Modules */
import {SharedModule}           from '../shared/shared.module';
/* Providers*/
import {DeveloperService}       from './shared/service/developer.service';
import {LogService}             from './shared/service/log.service';
import { HQLComponent } from './hql/hql.component';
import { UploadComponent } from './upload/upload.component';
import { ExceptionListComponent } from './exception/exception-list.component';
import { ExceptionListTableViewComponent } from './exception/exception-list-tableview.component';
import { ExceptionListFilterComponent } from './exception/exception-list-filter.component';
import { LogListComponent } from './log/log-list.component';
import { LogListNoFiltroComponent } from './log/log-list-nofiltro.component';
import { LogListNadaComponent } from './log/log-list-nada.component';
import { LogListFilterComponent } from './log/log-list-filter.component';
import { LogListTableViewComponent } from './log/log-list-tableview.component';
import { ConfigListComponent } from './config/config-list.component';
import { ConfigListTableViewComponent } from './config/config-list-tableview.component';
import { ConfigFormComponent } from './config/config-form.component';


@NgModule({
    imports: [SharedModule],
    declarations: [
        HQLComponent, 
        UploadComponent,
        ExceptionListComponent,
        ExceptionListTableViewComponent,
        ExceptionListFilterComponent,
        LogListComponent,
        LogListNoFiltroComponent,
        LogListNadaComponent,
        LogListFilterComponent,
        LogListTableViewComponent,
        ConfigListComponent,
        ConfigListTableViewComponent,
        ConfigFormComponent
    ],
    providers: [DeveloperService, LogService],
    exports: [
        HQLComponent,
        UploadComponent,
        ExceptionListComponent,
        ExceptionListTableViewComponent,
        ExceptionListFilterComponent,
        LogListComponent,
        LogListNoFiltroComponent,
        LogListNadaComponent,
        LogListFilterComponent,
        LogListTableViewComponent,
        ConfigListComponent,
        ConfigListTableViewComponent,
        ConfigFormComponent
    ]
})
export class DeveloperLibraryModule { }