import { Component, Input } from "@angular/core";
import { MessageService } from "../../shared/service/message.service";
import { Item } from "../../shared/data/item";
import { BitMessage } from "../../shared/data/bitmessage";

@Component({
  selector: "exception-list-tableview",
  template: `
<p-dataTable [value]="items" *ngIf="(items != null && items.length > 0)">
    <p-column field="login" header="Login" [sortable]="true"></p-column>
    <p-column field="concepto" header="Concepto" [sortable]="true"></p-column>
    <p-column field="method" header="Operación" [sortable]="true"></p-column>
    <p-column field="fecha" header="Hora" [sortable]="true">
        <ng-template let-log="rowData" pTemplate type="body">
            <span>{{log.fecha | date:"HH:mm"}}</span>
        </ng-template>
    </p-column> 
    <p-column styleClass="col-button">
        <ng-template let-log="rowData" pTemplate type="body">            
            <div class="btn-group" role="group">
                <button *ngIf="log.error" class="btn btn-danger btn-xs" (click)="showDatosLog($event,log.error,'Error');"> Error&nbsp;&nbsp;<span class="glyphicon glyphicon-alert"></span>
                </button>
            </div>
        </ng-template>
    </p-column>
</p-dataTable>    
     `
})
export class ExceptionListTableViewComponent {
  @Input()
  items: Item[];

  constructor(private messageService: MessageService) {}

  /** Muestra los datos de log en un diálogo*/
  showDatosLog(event, log: string, titulo: string) {
    let width: number = BitMessage.WIDTH;
    if (titulo === "Error") {
      width = 800;
    }
    this.messageService.sendMessage(new BitMessage(titulo, log, width));
  }
}
