import { BaseFilter } from "../../../base/shared/base.filter";
import { GeneralUtils } from "../../../shared/service/general-utils.service";

export class LogExceptionFilter extends BaseFilter
{    
   constructor(
      public login: string,
      public fecha: string,
      public desde: string,
      public hasta: string,
      public resultados: number,
      public pagina: number
   ) {
      super(resultados, pagina);
   }

   public reset() {
      super.reset();
      this.login = '';
      this.fecha = GeneralUtils.getTodayAsString();
      this.desde = '00:00';
      this.hasta = '23:59';
   }

   public copy(): LogExceptionFilter{
      return new LogExceptionFilter(this.login, this.fecha, this.desde, this.hasta, this.resultados, this.pagina);
   }

   public static newObject(): LogExceptionFilter{
       let filter = new LogExceptionFilter('', GeneralUtils.getTodayAsString(), 
                                          '00:00', '23:59', 
                                          BaseFilter.RESULTADOS_PAGE, BaseFilter.PAGE);
       return filter;
   }
}