import { BaseFilter } from "../../../base/shared/base.filter";
import { GeneralUtils } from "../../../shared/service/general-utils.service";

export class LogFilter extends BaseFilter
{
   constructor(
      public login: string,
      public fecha: string,
      public desde: string,
      public hasta: string,
      public tipoLog: string,
      public mostrarErrores: boolean,
      public resultados: number,
      public pagina: number
   ) { 
      super(resultados, pagina);
   }
    
   public reset() {
      super.reset();  
      this.login = '';
      this.fecha = GeneralUtils.getTodayAsString();
      this.desde = '00:00';
      this.hasta = '23:59';
      this.tipoLog = null;
      this.mostrarErrores = false;     
   }        
    
   public copy() {
      return new LogFilter(this.login, this.fecha, this.desde, this.hasta, this.tipoLog, 
                           this.mostrarErrores, this.resultados, this.pagina);
   }
    
   public static newObject(): LogFilter {
       let filter = new LogFilter('', GeneralUtils.getTodayAsString(), 
                                  '00:00', '23:59', null, false, BaseFilter.RESULTADOS_PAGE, BaseFilter.PAGE);
       return filter;
   }
}