import {Injectable}             from '@angular/core';
import {Http,
        Response}               from '@angular/http';
import {Observable}             from 'rxjs';

import {BaseCRUDService}        from '../../../base/shared/base.service';
import {HttpUtilsService}       from '../../../shared/service/http-utils.service';
import {MessageService}         from '../../../shared/service/message.service';
import {DomainCachedService}    from '../../../shared/service/domain-cached.service';
import {SessionSharedService}   from '../../../shared/service/session-shared.service';
import { Domain } from '../../../shared/data/domain';

/**
 Servicio que devuelve parámetros de configuración.
 */
@Injectable()
export class ConfiguracionService extends BaseCRUDService {

   public static STATIC_URL: string = 'configuracion';
   protected baseUrl: string = ConfiguracionService.STATIC_URL;

   constructor(
        protected messageService: MessageService,
        protected http: HttpUtilsService,
        protected domainService: DomainCachedService,
        protected sessionShared: SessionSharedService
    ) {
      super(messageService, http);
   }

   getAllConfiguracion(): Observable<Domain[]>  {
       return this.domainService.getDominio('configuracion');
   }

   /*getURLAutoevaluacion(codigoAutoevaluacion?: string): Observable<String> {
       return this.getAllConfiguracion().map(config => {
            let domainEntry = config.find(d => d.value === 'URL_PUBLICA_AUTOEVALUACION');
            let value = domainEntry && domainEntry.label;
            if(value && codigoAutoevaluacion) {
                value = value.replace('#codigoAutoevaluacion', codigoAutoevaluacion);
            }
            return value;
       });
   }*/

}