import {Injectable}       from '@angular/core';
import {Observable}         from 'rxjs'; 

import {HttpUtilsService} from '../../../shared/service/http-utils.service';
import {MessageService}   from '../../../shared/service/message.service';
import {LogFilter}        from '../data/log.filter';
import { BaseCRUDService } from '../../../base/shared/base.service';

@Injectable()
export class LogService extends BaseCRUDService
{
   private countAllLogsByFilterUrl = 'logs/count';
   private getAllLogsByFilterUrl = 'logs/filter';
   private getDominiosLogUrl = 'dominios/tipolog';

   constructor(
        protected messageService: MessageService,
        protected http: HttpUtilsService,
    ) {
      super(messageService, http);
   }

   getAllByFilter<T>(logFilter: LogFilter): Observable<T> {
      return this.http.getHttpPost(this.getAllLogsByFilterUrl, logFilter);
   }

   countAllByFilter(logFilter: LogFilter): Observable<number> {
      return this.http.getHttpPost(this.countAllLogsByFilterUrl, logFilter);
   }

}