import {Component}      from '@angular/core';

import {UploadService}  from '../../shared/service/upload.service';
import {MessageService} from '../../shared/service/message.service';
import { BitMessage } from '../../shared/data/bitmessage';

@Component({

    selector: 'upload',
    templateUrl: './upload.component.html'
})
export class UploadComponent {
    private filesToUpload: Array<File>;
    
    constructor(
        private uploadService: UploadService,
        private messageService: MessageService
    ) {}
    
    fileChange(files: Array<File>){
        this.filesToUpload = files;
    }

    submit(){
        this.uploadService.upload(null, this.filesToUpload, {}).then((result: any) => {
            console.log(result);
            this.messageService.sendNotification(new BitMessage("Informació", result));
        }, (error) => {
            console.log(error);
            let objError = JSON.parse(error);
            this.messageService.sendNotification(new BitMessage("Error", objError.text, undefined, undefined, undefined, BitMessage.ERROR));
        });
    }

    get noFiles(){
        return (this.filesToUpload == null || (this.filesToUpload != null && this.filesToUpload.length == 0));
    }
}