import {Input,
        Component} from '@angular/core';
import {AyudaService} from '../service/ayuda.service';

@Component({
    selector: 'bit-boton-ayuda',
    template: `
    <button *ngIf="boton" 
        type="button"
        (click)="mostrarAyuda()"
        [ngClass]="'btn btn-transparent ' + extraClass"
    >Ajuda&nbsp;&nbsp;<span class="fa fa-life-ring"></span></button>

    <i *ngIf="!boton" 
        [ngClass]="'btn-ayuda fa fa-question ' + extraClass"
        (click)="mostrarAyuda();"
    ></i>
    `
})
export class BitBotonAyudaComponent {

    @Input() ayuda: string;
    @Input() boton: boolean = false; // show a little [?] or a full button
    @Input() extraClass: string = ''; // extra CSS classes for HTML component

    constructor(
        private ayudaService: AyudaService
    ) {
    }

    mostrarAyuda() {
        this.ayudaService.mostrarAyuda(this.ayuda);
    }

}