import {Component,
        Input}              from '@angular/core';
import {FormControl}        from '@angular/forms';
import {CustomValidators}   from '../service/custom-validators.service';
import {FocusService}       from '../service/focus.service';

//inputs: ['control: control', 'onField: onField'],
@Component({
    selector: 'control-messages',
    template: `<div *ngIf="errorMessage !== null"><span class="mensaje-error-input">{{errorMessage}}</span></div>`    
})
export class BitControlMessages {
    @Input() control: FormControl;
    @Input() field: string; 

    //constructor( @Host() private formDir: FormGroup) { }
    constructor(private focusService:FocusService) { }

    get errorMessage() {
        if (this.focusService.getFocusedElement()!==this.field) {       
            for (let propertyName in this.control.errors) {
                // If control has a error
                if (this.control.errors.hasOwnProperty(propertyName) && this.control.touched) {
                    // Return the appropriate error message from the Validation Service
                    return CustomValidators.getValidatorErrorMessage(propertyName);
                }
            }
            return null;
        }
    }
}