import {Component, 
    OnChanges,
    Input}              from '@angular/core';

import {Domain}             from '../data/domain';

@Component({    
selector: 'bit-domain-value',
template: `
<span>{{translatedValue}}</span>
`
})
export class BitDomainValueComponent implements OnChanges {
translatedValue: String = 'carregant...';

@Input() value: string;
@Input() emptyText: String = "";
@Input() data: Domain[];

constructor() {}

ngOnChanges() {
    // cada vez que cambia algo en el input, recalculamos
    this.translatedValue = this.resolveTranslatedValue();
}

resolveTranslatedValue(): String {
    // buscar traducción para el valor en el dominio
    let domainMatch = this.data && this.data.find(obj => obj.value == this.value);
    
    if(domainMatch) {
        return domainMatch.label;
    } else if(this.value) {
        return new String(`??${this.value}??`);
    } else {
        return this.emptyText;
    }
}

}