import {Component, 
    Input,
    Output,
    EventEmitter} from '@angular/core';

/**
* Componente que muestra miga de pan y toolbar
*/
@Component({

selector: 'bit-header',
template: `
<div class="row container" [class.container-bread-btn-fixed]="breadcrumb" [class.cotainer-bread-btn-lite]="!breadcrumb">
    <div
        [ngClass]="[colsBreadcrumb  ? ('col-sm-' + colsBreadcrumb): (masacciones ? 'col-sm-5' : 'col-sm-7')]">
        <!-- ruta de donde nos encontramos (miga de pan) -->
        <bit-breadcrumb *ngIf="breadcrumb" [breadcrumb]="breadcrumb"></bit-breadcrumb>
    </div>
    <div *ngIf="noToolbar === false"
        [ngClass]="[colsBreadcrumb  ? ('col-sm-' + (12-colsBreadcrumb)): (masacciones ? 'col-sm-7' : 'col-sm-5')]">
        <!-- botonera de acciones -->    
        <bit-toolbar 
            [componentId]="componentId" 
            [femenino]="femenino"
            [otherActionsDropdown]="otherActionsDropdown"
	    [ayuda]="ayuda"
            (onToolbarButtonPressed)="onTBPressed($event)"></bit-toolbar>
    </div>
</div>
`
})
export class BitHeaderComponent{
@Input() componentId: string = "BASE";  //id del componente donde está asociado el header. Por defecto BASE
@Input() toolbar: any = {};
@Input() noToolbar: boolean = false;
@Input() otherActionsDropdown: boolean = false; // determina si las "other actions" deben mostrarse en línea o como un desplegable
@Input() breadcrumb: any[];
@Input() masacciones: any[];
@Input() colsBreadcrumb: number;
@Input() femenino: boolean = false;     // género femenino (para los nombres de botones) o no
@Input() ayuda: string; // clave de la ayuda contextual para la botonera

@Output() onToolbarButtonPressed = new EventEmitter<string>();

/** Tenemos que capturar el evento y volver a subirlo, por diseño Angular2 no permite enviar un evento de un nieto a su abuelo, solo
 * de hijo a padre
 */
onTBPressed(button){
    this.onToolbarButtonPressed.emit(button);
}
}