import {Component}          from '@angular/core';

import {AyudaContextual}    from '../data/ayudacontextual';
import {AyudaService}       from '../service/ayuda.service';

@Component({   

   selector: 'bit-help',     
   template: `
        <div class="ventana-ayuda" *ngIf="ayuda">
            <div class="ayuda-header">{{ayuda.header}}
                <span class="fa fa-close" (click)="hideAyuda();"></span>
            </div>
            <div class="ayuda-body">
                <p class="ayuda-subtitulo" [innerHTML]="ayuda.title"></p>
                <p [innerHTML]="ayuda.body"></p>
            </div>
        </div>
    `
})
export class BitHelpComponent {
    
    ayuda: AyudaContextual;

    constructor(
        protected ayudaService: AyudaService
    ) {
        this.ayuda = null;
        // cada vez que el servicio emite una nueva ayuda, la mostramos
        ayudaService.mostrar.subscribe(ayuda => {
            console.log('Mostrando ayuda', ayuda);
            this.ayuda = ayuda;
        })
    }

    /** Oculta el modal con los avisos */
    hideAyuda(){
        this.ayuda = null;
    }

}