import {
  Component,
  Input,
  Output,
  EventEmitter,
  ChangeDetectionStrategy
} from "@angular/core";

/**
 * Componente que muestra miga de pan y toolbar
 */
@Component({
  selector: "bit-store-header",
  changeDetection: ChangeDetectionStrategy.OnPush,
  templateUrl: "bit-store-header.component.html"
})
export class BitStoreHeaderComponent {
  @Input() toolbar: any = {};
  @Input() noToolbar: boolean = false;
  @Input() otherActionsDropdown: boolean = false; // determina si las "other actions" deben mostrarse en línea o como un desplegable
  @Input() breadcrumb: any[];
  @Input() masacciones: any[];
  @Input() colsBreadcrumb: number;
  @Input() femenino: boolean = false; // género femenino (para los nombres de botones) o no
  @Input() ayuda: string; // clave de la ayuda contextual para la botonera

  @Output() onToolbarButtonPressed = new EventEmitter<string>();

  /** Tenemos que capturar el evento y volver a subirlo, por diseño Angular2 no permite enviar un evento de un nieto a su abuelo, solo
   * de hijo a padre
   */
  onTBPressed(button) {
    this.onToolbarButtonPressed.emit(button);
  }
}
