import { Component, Input } from '@angular/core';

/**
 * Componente general que muestra controles de sesión de usuario.
 * 
 * Informa del login actualmente en sesión
 */
@Component({    
    selector: 'bit-user-controls',
    template: `
    <span *ngIf="usuario" class="userControls"><span class="fa fa-user" title="{{json}}"></span>&nbsp;&nbsp;{{usuario.nombreCompleto}} ({{usuario.login}})&nbsp;&nbsp;</span>
    `
})
export class BitUserControlsComponent {
    @Input() usuario;
    userJSON: string;

    constructor() {}

    get json(): string {
        return this.usuario && JSON.stringify(this.usuario, null, 4);
    }

}