import { Component, forwardRef, ChangeDetectorRef, Input, Output, EventEmitter } from "@angular/core";

import { AyudaService } from "../../service/ayuda.service";
import { NG_VALUE_ACCESSOR } from "@angular/forms";
import { BitCustomComponent } from "./bit-custom.component";

export const CUSTOM_INPUT_AUTOCOMPLETE_CONTROL_VALUE_ACCESSOR: any = {
  provide: NG_VALUE_ACCESSOR,
  useExisting: forwardRef(() => BitAutoCompleteComponent),
  multi: true
};

@Component({
  selector: "bit-autocomplete",
  templateUrl: "bit-autocomplete.component.html",
  providers: [CUSTOM_INPUT_AUTOCOMPLETE_CONTROL_VALUE_ACCESSOR]
})
export class BitAutoCompleteComponent extends BitCustomComponent {
  @Input()
  suggestions: any[];
  @Input()
  suggestionField: string;
  @Input()
  multiple: boolean = false;
  @Output()
  completeMethod = new EventEmitter<string>();
  @Output()
  onSelect = new EventEmitter<string>();

  constructor(protected ayudaService: AyudaService, protected changeDetectorRef: ChangeDetectorRef) {
    super(ayudaService, changeDetectorRef);
  }

  search(event: any) {
    this.completeMethod.emit(event);
  }

  selectValue(event: any) {
    this.onSelect.emit(event);
  }
}
