import { ChangeDetectorRef } from "@angular/core";
import { Input } from "@angular/core";

import { AyudaService } from "../../service/ayuda.service";
import { BitCustomComponent } from "./bit-custom.component";

/** Clase general para componentes personalizados de tipo Fecha como puede ser BitDate, BitTime y BitDateTime */
export abstract class BitCalendarComponent extends BitCustomComponent {
  // calendarios
  @Input()
  fechaMinima: Date; // fecha mínima seleccionable
  @Input()
  fechaMaxima: Date; // fecha máxima seleccionable
  @Input()
  calendarReadOnlyInput: boolean; // desabilitar edicion por teclado

  constructor(protected ayudaService: AyudaService, protected changeDetectorRef: ChangeDetectorRef) {
    super(ayudaService, changeDetectorRef);
  }

  public LOCALE_ES: any = {
    firstDayOfWeek: 1,
    closeText: "Cerrar",
    prevText: "<Ant",
    nextText: "Sig>",
    currentText: "Hoy",
    monthNames: [
      "enero",
      "febrero",
      "marzo",
      "abril",
      "mayo",
      "junio",
      "julio",
      "agosto",
      "septiembre",
      "octubre",
      "noviembre",
      "diciembre"
    ],
    monthNamesShort: ["ene", "feb", "mar", "abr", "may", "jun", "jul", "ago", "sep", "oct", "nov", "dic"],
    dayNames: ["domingo", "lunes", "martes", "miércoles", "jueves", "viernes", "sábado"],
    dayNamesShort: ["dom", "lun", "mar", "mié", "jue", "vie", "sáb"],
    dayNamesMin: ["D", "L", "M", "X", "J", "V", "S"],
    weekHeader: "Sm",
    dateFormat: "dd/mm/yy",
    firstDay: 1,
    isRTL: false,
    showMonthAfterYear: false,
    yearSuffix: "",
    timeOnlyTitle: "Elegir una hora",
    timeText: "Hora",
    hourText: "Horas",
    minuteText: "Minutos",
    secondText: "Segundos",
    millisecText: "Milisegundos",
    microsecText: "Microsegundos",
    timezoneText: "Uso horario",
    timeFormat: "HH:mm",
    timeSuffix: "",
    amNames: ["a.m.", "AM", "A"],
    pmNames: ["p.m.", "PM", "P"]
  };
}
