import { Component, forwardRef, ChangeDetectorRef } from "@angular/core";
import { NG_VALUE_ACCESSOR } from "@angular/forms";

import { AyudaService } from "../../service/ayuda.service";
import { BitCalendarComponent } from "./bit-calendar.component";
import { GeneralUtils } from "../../service/general-utils.service";

export const CUSTOM_INPUT_DATETIME_CONTROL_VALUE_ACCESSOR: any = {
  provide: NG_VALUE_ACCESSOR,
  useExisting: forwardRef(() => BitDateTimeComponent),
  multi: true
};

@Component({
  selector: "bit-datetime",
  templateUrl: "bit-datetime.component.html",
  providers: [CUSTOM_INPUT_DATETIME_CONTROL_VALUE_ACCESSOR]
})
export class BitDateTimeComponent extends BitCalendarComponent {
  constructor(protected ayudaService: AyudaService, protected changeDetectorRef: ChangeDetectorRef) {
    super(ayudaService, changeDetectorRef);
  }

  get value_lectura(): string {
    if (this.value == null || this.value == "") {
      return "";
    } // si es null o undefined (es lo que evalúa el "==null")
    else {
      return GeneralUtils.getDateTimeAsString(GeneralUtils.stringToDate(this.value));
    }
  }
}
