import { Component, forwardRef, ChangeDetectorRef } from "@angular/core";

import { AyudaService } from "../../service/ayuda.service";
import { NG_VALUE_ACCESSOR } from "@angular/forms";
import { BitCustomComponent } from "./bit-custom.component";

export const CUSTOM_INPUT_SWITCH_CONTROL_VALUE_ACCESSOR: any = {
  provide: NG_VALUE_ACCESSOR,
  useExisting: forwardRef(() => BitSwitchComponent),
  multi: true
};

@Component({
  selector: "bit-switch",
  templateUrl: "bit-switch.component.html",
  providers: [CUSTOM_INPUT_SWITCH_CONTROL_VALUE_ACCESSOR]
})
export class BitSwitchComponent extends BitCustomComponent {
  constructor(protected ayudaService: AyudaService, protected changeDetectorRef: ChangeDetectorRef) {
    super(ayudaService, changeDetectorRef);
  }

  get value_lectura(): string {
    return this.value ? "Sí" : "No";
  }
}
