import { Component, forwardRef, ChangeDetectorRef } from "@angular/core";
import { NG_VALUE_ACCESSOR, ControlValueAccessor } from "@angular/forms";

import { AyudaService } from "../../service/ayuda.service";
import { GeneralUtils } from "../../service/general-utils.service";
import { BitCalendarComponent } from "./bit-calendar.component";

export const CUSTOM_INPUT_TIME_CONTROL_VALUE_ACCESSOR: any = {
  provide: NG_VALUE_ACCESSOR,
  useExisting: forwardRef(() => BitTimeComponent),
  multi: true
};

@Component({
  selector: "bit-time",
  templateUrl: "bit-time.component.html",
  providers: [CUSTOM_INPUT_TIME_CONTROL_VALUE_ACCESSOR]
})
export class BitTimeComponent extends BitCalendarComponent {
  constructor(protected ayudaService: AyudaService, protected changeDetectorRef: ChangeDetectorRef) {
    super(ayudaService, changeDetectorRef);
  }

  transformData(value: any): any {
    let v;
    if (value) {
      v = GeneralUtils.getTimeAsString(GeneralUtils.stringToDate(value));
    }
    return v;
  }

  get value_lectura(): string {
    if (this.value == null || this.value == "") {
      return "";
    } // si es null o undefined (es lo que evalúa el "==null")
    else {
      return GeneralUtils.getTimeAsString(GeneralUtils.stringToTime(this.value));
    }
  }
}
