
export class Idioma
{
    private static seleccionado: Idioma;
    public static ca: Idioma = new Idioma("ca",'Català');
    public static es: Idioma = new Idioma("es",'Español');
    
    constructor(        
        public value: string,
        public label: string
    ) {}

    public static set      (idioma  : Idioma)    { Idioma.seleccionado = idioma; }
    public static setCodigo(idioma  : string)    { Idioma.seleccionado = (idioma==="es" || idioma==="es-ES")?Idioma.es:Idioma.ca; }
    public static get      ()       : Idioma     { return (Idioma.seleccionado)?Idioma.seleccionado:Idioma.ca; }
    public static getCodigo()       : string     { return Idioma.get().value; }
    public static esCatalanSeleccionado ()   : boolean { return Idioma.esCatalan (Idioma.getCodigo()); }
    public static esEspanyolSeleccionado()   : boolean { return Idioma.esEspanyol(Idioma.getCodigo()); }
    
    public static esCatalan (idioma: string) : boolean { return Idioma.ca.value == idioma; }
    public static esEspanyol(idioma: string) : boolean { return Idioma.es.value == idioma; }

};