import {Pipe,
    PipeTransform}  from '@angular/core';

@Pipe({
name: 'removeLineBreaks'
})
/**
* Acorta un texto con saltos de línea, sustituyendo los saltos por "//" y limitando la cadena final a 200 caracteres
*/
export class RemoveLineBreaksPipe implements PipeTransform{

    transform(str: string): string {
        if(str.indexOf('\n') > 0) {
            str = str.split('\n').filter(line => line.trim().length > 0).join(' // ');
        }
        if(str.length > 200) {
            str = str.substring(0, 200) + ' ...';
        }
        return str;
    }

}