import {Injectable}             from '@angular/core';
import {Router,
        Resolve,
        ActivatedRouteSnapshot} from '@angular/router';
import {Observable}             from 'rxjs';

import {Domain}                 from '../data/domain';
import {DomainCachedService}    from '../service/domain-cached.service';

@Injectable()
export class DomainResolve implements Resolve<{ [key:string]:Observable<Domain[]> }>{

    constructor(private service: DomainCachedService,
                private router: Router) { }

    /**
     * Permite obtener los datos del dominio de tipos de log de la cache de sessión o del servidor si no tuviéramos
     * los datos en caché
     */            
    resolve(route: ActivatedRouteSnapshot): { [key:string]:Observable<Domain[]> } {
        console.log("Resolviendo la precarga de datos");
        let dominios: string[] = route.data['dominios'];
        if (dominios == null){
            console.log("No me ha llegado el dominio a cargar. No podemos retornar lista de valores");
            //return Promise.resolve([]);
        }
        let listaDominios: { [key:string]:Observable<Domain[]> } = {};
        for (let dom of dominios){
            //console.log("Vamos a recuperar el dominio, cacheado o no");
            let domServer = this.service.getDominio(dom);                
            listaDominios[dom] = domServer;
        }
        return listaDominios;
        
  }
   
}