import {Injectable,
    EventEmitter}       from '@angular/core';

import {AyudaContextual}    from '../data/ayudacontextual';

@Injectable()
export class AyudaService {
public mostrar: EventEmitter<AyudaContextual> = new EventEmitter<AyudaContextual>();

    public static AYUDAS = []; // Inicializar desde la aplicacion cliente

    protected mapaAyudas: Map<string, AyudaContextual>; // mapa de ayudas contextuales del sistema

    constructor() {
        this.loadAyudas();
    }

    // procesa el fichero app.ayudas.json y crea el mapa para acceder luego directamente por clave
    private loadAyudas() {
        this.mapaAyudas = new Map<string, AyudaContextual>();
        if(AyudaService.AYUDAS) {
            AyudaService.AYUDAS.forEach(elem => {
                this.mapaAyudas.set(elem.key, AyudaContextual.newObject(elem));
            })
            console.log(`Cargadas ${this.mapaAyudas.size} ayudas contextuales`);
        } else {
            console.warn('No se han podido cargar las ayudas contextuales de la aplicacion.');
        }
    }

    mostrarAyuda(key: string) {
        if(this.mapaAyudas.has(key)) {
            this.mostrar.emit(this.mapaAyudas.get(key));
        } else {
            console.warn(`No existe ayuda para la clave [${key}]`);
        }
    }

}