import {Injectable}         from '@angular/core';
import {Observable}         from 'rxjs';

import {BaseCRUDService}    from '../../base/shared/base.service';
import {Domain}             from '../data/domain';
import {HttpUtilsService}   from '../service/http-utils.service';
import {MessageService}     from '../service/message.service';

@Injectable()
export class DomainService extends BaseCRUDService {
    private getDominiosBaseUrl = 'dominios/';
    
   constructor(
        protected messageService: MessageService,
        protected http: HttpUtilsService
    ) {
      super(messageService, http);
   }

    /**TODO: reconstruir cada elemento de id, valor a label, value */    
    getDominio(dominio: string, params?: string[]): Observable<Domain[]> {
        let url = this.getDominiosBaseUrl+dominio;
        if (params && params.length>0) {
            url = url + '?' + params.join('&');
        }
        let obj = this.http.getHttpGet<Domain[]>(url);
        return obj;       
    }
       
    
}