import {Injectable}                 from '@angular/core';
import {Observable, ReplaySubject}  from 'rxjs';


@Injectable()
export class ToolbarService{
    //private observableToolbarSource = new BehaviorSubject<any>(null);
    private observableToolbarSource = new ReplaySubject<any>(10);
    public observableToolbar: Observable<any>;

    constructor() { 
        console.log("ToolbarService creado");
        //el toolbar al suscribirse recibirá eiempre los últimos n mensajes (toolbar) enviados. Es para protegernos y garantizar que cuando un toolbar
        //se susbscribe después de que el componente padre envíe su toolbar, entonces si se cuelan delante más toolbars, al menos lo reciba
        //OJO!. Juntar share() con ReplaySubject o publishReplay hace que no se comporte como se esperaba
        this.observableToolbar = this.observableToolbarSource.asObservable();//.share();//.publishReplay(3).refCount();
    }  

    updateToolbar(componentId: string, toolbar: any){
        toolbar.componentId = componentId;
        this.observableToolbarSource.next(toolbar);
    }
}