import { NgModule } from "@angular/core";
import { ReactiveFormsModule, FormsModule } from "@angular/forms";
import { CommonModule } from "@angular/common";
import { HttpClientModule } from "@angular/common/http";

import {
  FocusRegisterDirective,
  BitDialogComponent,
  BitNotificationComponent,
  BitNotificationFrontComponent,
  BitControlMessages,
  BitInputComponent,
  BitEditorComponent,
  BitSelectComponent,
  BitSelectMultipleComponent,
  BitDomainValueComponent,
  BitColumnBooleanComponent,
  CapitalizePipe,
  OtherToolbarActionPipe,
  PipeCantidadMoneda,
  RemoveLineBreaksPipe,
  BitFooterComponent,
  BitHeaderComponent,
  BitToolbarComponent,
  BitBreadCrumbComponent,
  BitLoadingComponent,
  BitUploadComponent,
  BitFormUploadComponent,
  BitHelpComponent,
  BitUserControlsComponent,
  BitBotonAyudaComponent,
  BitStoreBreadCrumbComponent,
  BitStoreHeaderComponent,
  BitStoreFooterComponent,
  BitStoreToolbarComponent
} from "./index";

import * as newComponents from "./component/form";

import { SharedModule as primeSharedModule } from "primeng/components/common/shared";
import { CalendarModule } from "primeng/components/calendar/calendar";
import { DropdownModule } from "primeng/components/dropdown/dropdown";
import { EditorModule } from "primeng/components/editor/editor";
import { MultiSelectModule } from "primeng/components/multiselect/multiselect";
import { PaginatorModule } from "primeng/components/paginator/paginator";
import { CheckboxModule } from "primeng/components/checkbox/checkbox";
import { RadioButtonModule } from "primeng/components/radiobutton/radiobutton";
import { DataTableModule } from "primeng/components/datatable/datatable";
import { TabViewModule } from "primeng/components/tabview/tabview";
import { DialogModule } from "primeng/components/dialog/dialog";
import { AccordionModule } from "primeng/components/accordion/accordion";
import { AutoCompleteModule } from "primeng/components/autocomplete/autocomplete";
import { InputSwitchModule } from "primeng/components/inputswitch/inputswitch";
import { TooltipModule } from "primeng/components/tooltip/tooltip";
import { OverlayPanelModule } from "primeng/components/overlaypanel/overlaypanel";
import { MessagesModule } from "primeng/components/messages/messages";
import { MenuModule } from "primeng/components/menu/menu";
import { MenubarModule } from "primeng/components/menubar/menubar";
import { MegaMenuModule } from "primeng/components/megamenu/megamenu";
import { GrowlModule } from "primeng/components/growl/growl";

@NgModule({
  imports: [
    CommonModule,
    ReactiveFormsModule,
    FormsModule,
    HttpClientModule,
    CalendarModule,
    DropdownModule,
    EditorModule,
    MultiSelectModule,
    PaginatorModule,
    CheckboxModule,
    RadioButtonModule,
    DataTableModule,
    TabViewModule,
    DialogModule,
    MenuModule,
    MegaMenuModule,
    MenubarModule,
    GrowlModule,
    primeSharedModule,
    AccordionModule,
    AutoCompleteModule,
    InputSwitchModule,
    TooltipModule,
    OverlayPanelModule,
    MessagesModule
  ],
  declarations: [
    FocusRegisterDirective,
    BitDialogComponent,
    BitNotificationComponent,
    BitNotificationFrontComponent,
    BitControlMessages,
    BitBotonAyudaComponent,
    BitInputComponent,
    BitEditorComponent,
    BitSelectComponent,
    BitSelectMultipleComponent,
    BitDomainValueComponent,
    BitColumnBooleanComponent,
    BitFooterComponent,
    CapitalizePipe,
    OtherToolbarActionPipe,
    RemoveLineBreaksPipe,
    PipeCantidadMoneda,
    BitHeaderComponent,
    BitToolbarComponent,
    BitBreadCrumbComponent,
    BitLoadingComponent,
    BitUploadComponent,
    BitFormUploadComponent,
    BitHelpComponent,
    BitUserControlsComponent,
    BitStoreBreadCrumbComponent,
    BitStoreHeaderComponent,
    BitStoreFooterComponent,
    BitStoreToolbarComponent,
    ...newComponents.components
  ],
  exports: [
    FocusRegisterDirective,
    CommonModule,
    ReactiveFormsModule,
    FormsModule,
    HttpClientModule,
    BitDialogComponent,
    BitNotificationComponent,
    BitNotificationFrontComponent,
    BitControlMessages,
    BitBotonAyudaComponent,
    BitInputComponent,
    BitEditorComponent,
    BitSelectComponent,
    BitSelectMultipleComponent,
    BitDomainValueComponent,
    BitColumnBooleanComponent,
    BitFooterComponent,
    CapitalizePipe,
    OtherToolbarActionPipe,
    RemoveLineBreaksPipe,
    PipeCantidadMoneda,
    BitHeaderComponent,
    BitToolbarComponent,
    BitBreadCrumbComponent,
    BitLoadingComponent,
    BitUploadComponent,
    BitFormUploadComponent,
    BitHelpComponent,
    CalendarModule,
    DropdownModule,
    EditorModule,
    MultiSelectModule,
    PaginatorModule,
    CheckboxModule,
    RadioButtonModule,
    DataTableModule,
    TabViewModule,
    DialogModule,
    primeSharedModule,
    AccordionModule,
    AutoCompleteModule,
    InputSwitchModule,
    TooltipModule,
    OverlayPanelModule,
    MessagesModule,
    MenuModule,
    MegaMenuModule,
    MenubarModule,
    GrowlModule,
    BitUserControlsComponent,
    BitStoreBreadCrumbComponent,
    BitStoreHeaderComponent,
    BitStoreFooterComponent,
    BitStoreToolbarComponent,
    ...newComponents.components
  ]
})
export class SharedModule {}
