import {OnInit, 
        Component}          from '@angular/core';
import {FormBuilder,
        FormControl,
        Validators}         from '@angular/forms';

import {TestService}       from '../shared/test.service';

@Component({
    selector: 'hello',
    template: `
    <form role="form">
        <label for="nombre">Nombre:</label>
        <input type="text" id="nombre" [(ngModel)]="object.nombre" [ngModelOptions]="{standalone: true}">
        <button (click)="testApi()">click me to test API</button>
    </form>
    <br>
    <div>Resultado: {{result}}</div>
    `
})
export class TestComponent implements OnInit { 
    result: string;
    object: {
        nombre: string
    };
    
    constructor(public testService: TestService){
        console.log("HelloComponent construido");
        this.object = { nombre: ''};
    }

    ngOnInit(){
        console.log("HelloComponent listo para jugar")
    }

    testApi(){
        console.log("testApi llamado");
        this.testService.hello(this.object.nombre).subscribe(
            r => {                
                console.log(r);                
                this.result = r;
            },
            error => {
                console.log(error);
                this.result = error
            }
        ) 
    }
}