import {Injectable}         from '@angular/core';
import {Observable}         from 'rxjs';

import { BaseCRUDService }  from '../../base/index';
import { FormType, HttpUtilsService, MessageService } from '../../shared/index';

@Injectable()
export class TestService extends BaseCRUDService {

    private helloUrl = 'hello';

    constructor(
        protected messageService: MessageService,
        protected http: HttpUtilsService
    ) {
      super(messageService, http);
    }

    hello(name: string): Observable<string>{        
        let query = `${this.helloUrl}?name=${name}`
        return this.http.getHttpGet<string>(query);
    }
}